-------------------------------------------------------------------------
-- GotAnswers, copyright 2017 Taomi@Hellfire-EU (candy@taomi.net)      --
--   All rights reserved. Unauthorized redistribution is prohibited.   --
-------------------------------------------------------------------------

GotAnswersConfig = {}

local gotAnswersFrame = CreateFrame('Frame', 'GotAnswers')
gotAnswersFrame:RegisterEvent('GOSSIP_SHOW')
gotAnswersFrame:RegisterEvent('QUEST_DETAIL')
gotAnswersFrame:RegisterEvent('QUEST_COMPLETE')

gotAnswersFrame.Answers = {
	-- English, 12th anniversary
	["Let us test your knowledge of history, then! Before succumbing to magical addiction, the Wretched were once members of which race?"] = 1, -- Blood Elves.
	["Let us test your knowledge of history, then! Before the Cataclysm, where could the remains of Mankrik's wife be found?"] = 4, -- The Barrens.
	["Let us test your knowledge of history, then! Bloodfeather, Windfury and Witchwing are all types of which race?"] = 1, -- Harpy.
	["Let us test your knowledge of history, then! Cro Threadstrong continually threatened what specific type of vendor in Shattrath City?"] = 2, -- Fruit Vendor.
	["Let us test your knowledge of history, then! In Zandali, the language of the trolls, what does \"atal'ai\" mean?"] = 4, -- Devoted Ones.
	["Let us test your knowledge of history, then! King Krush, King Mosh, and King Dred are all what type of creature?"] = 2, -- Devilsaur.
	["Let us test your knowledge of history, then! Razormane and Bristleback are two feuding tribes of which race?"] = 1, -- Quillboar.
	["Let us test your knowledge of history, then! The Night Elves and the dragonflights stood against the armies of the Qiraji in what war?"] = 3, -- War of the Shifting Sands.
	["Let us test your knowledge of history, then! This cult was affiliated with the orcish Shadow Council and included members such as Nagaz and Marez Cowl."] = 3, -- Argus Wake.
	["Let us test your knowledge of history, then! What Goblin trading company is known for plundering the natural resources of Azeroth?"] = 2, -- Venture Company.
	["Let us test your knowledge of history, then! What Pandaria creatures are the embodiments of negative emotions including doubt, despair, and anger?"] = 4, -- Sha.
	["Let us test your knowledge of history, then! What are the final words from this Headless Horseman quote: \"It is over, your search is done! Let fate choose now, ...\""] = 3, -- \"the righteous one!\"
	["Let us test your knowledge of history, then! What area was reshaped by Goblins to resemble the symbol of the Horde?"] = 1, -- Azshara.
	["Let us test your knowledge of history, then! What dragon appears in the Human guise of Lord Victor Nefarius?"] = 3, -- Nefarian.
	["Let us test your knowledge of history, then! What is a Grummle's most prized personal possession?"] = 3, -- A Luckydo.
	["Let us test your knowledge of history, then! What is the highest rank that can be bestowed on a night elf Watcher?"] = 3, -- Warden.
	["Let us test your knowledge of history, then! What is the name of the bride that connects the Arathi Highlands and the Wetlands?"] = 4, -- Thandol Span.
	["Let us test your knowledge of history, then! What is the name of the desert that surrounds the Caverns of Time?"] = 2, -- Tanaris.
	["Let us test your knowledge of history, then! What is the name of the mate of Har'koa?"] = 1, -- Loque'nahak.
	["Let us test your knowledge of history, then! What is the name of the red dragon whose skull is on display in the Hall of Explorers?"] = 4, -- Tyranastrasz.
	["Let us test your knowledge of history, then! What phrase means \"Safe journey\" in the language of the draenei?"] = 2, -- Dioniss aca.
	["Let us test your knowledge of history, then! What pit lord was the ruler of Outland before being imprisoned by Illidan Stormrage?"] = 4, -- Magtheridon.
	["Let us test your knowledge of history, then! What was the name of the Human that kept Thrall as a slave in Durnholde Keep?"] = 4, -- Aedelas Blackmoore.
	["Let us test your knowledge of history, then! What was the name of the Human who helped Thrall escape his imprisonment in Durnholde Keep?"] = 4, -- Taretha Foxton.
	["Let us test your knowledge of history, then! What was the name of the first pandaren to ever tame a cloud serpent?"] = 1, -- Jiang.
	["Let us test your knowledge of history, then! What was the name of the once benevolent spiritual leader in Stormwind City that sided with Deathwing?"] = 1, -- Benedictus.
	["Let us test your knowledge of history, then! Where was Dalaran originally located in the Eastern Kingdoms?"] = 3, -- Hillsbrad Foothills.
	["Let us test your knowledge of history, then! Which Alliance city located in Darkshore was destroyed by Deathwing's return?"] = 3, -- Auberdine.
	["Let us test your knowledge of history, then! Which Orc was responsible for opening numerous portals on Draenor and shattering the Orc homeworld?"] = 1, -- Ner'zhul.
	["Let us test your knowledge of history, then! Which apothecary cannot be found in Shadowfang Keep during the Love is in the Air event?"] = 3, -- Copeland.
	["Let us test your knowledge of history, then! Which arm and which eye did Zul'jin lose during his captivity and eventual escape?"] = 1, -- Right eye; left arm.
	["Let us test your knowledge of history, then! Which musical trinket could be used to invoke spontaneous dancing in others against their will?"] = 1, -- Piccolo of the Flaming Fire.
	["Let us test your knowledge of history, then! Which night elf was appointed the jailor of Illidan Stormrage?"] = 3, -- Maiev Shadowsong.
	["Let us test your knowledge of history, then! Which of the following is not a possible result from drinking a Noggenfogger Elixer?"] = 4, -- You breathe fire.
	["Let us test your knowledge of history, then! Which of the following is not an Orc clan?"] = 3, -- Bloodfang.
	["Let us test your knowledge of history, then! Which paladin was not among the five when the Silver Hand was originally created?"] = 2, -- Alexandros.
	["Let us test your knowledge of history, then! Which son of an Alliance traitor would one day become a leader of the Syndicate?"] = 4, -- Aliden.
	["Let us test your knowledge of history, then! Who became Ragnaros' second Majordomo, protecting the entrance of Sulfuron Keep in the Firelands?"] = 1, -- Majordomo Staghelm.
	["Let us test your knowledge of history, then! Who became the Lich King after Arthas was defeated?"] = 2, -- Bolvar Fordragon.
	["Let us test your knowledge of history, then! Who was Jaina Proudmoore's mentor in the Kirin Tor?"] = 1, -- Archmage Antonidas.
	["Let us test your knowledge of history, then! Who was the brother of Varok Saurfang and the only Orc to fight in the War of the Ancients?"] = 1, -- Broxigar.
	["Let us test your knowledge of history, then! Who was the first to leave pandaria on the back of the sea turtle, Shen-zin Su?"] = 4, -- Liu Lang.
	["Let us test your knowledge of history, then! Who was the naga lieutenant of Illidan and once handmaiden of Queen Azshara?"] = 2, -- Vashj.
	-- German, 12th anniversary
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Bevor sie der Magiesucht erlagen, gehörten die Getriebenen zu welchem Volk?"] = 1, -- Blutelfen.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Blutfedern, Windfurien und Hexenschwingen gehören alle zu welchem Volk?"] = 1, -- Harpyien.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Der Schädel welches roten Drachen wird in der Halle der Forscher ausgestellt?"] = 4, -- Tyranastrasz.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! In welchem Krieg standen die Nachtelfen und Drachenschwärme den Armeen der Qiraji gegenüber?"] = 3, -- Der Krieg der Sandstürme.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Klingenmähnen und Borstennacken sind zwei verfeindete Stämme welches Volkes?"] = 1, -- Stacheleber.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Was für Kreaturen sind König Knirsch, König Mosh und König Dred?"] = 2, -- Teufelssaurier.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Was heißt \"atal'ai\" in Zandali, der Sprache der Trolle?"] = 4, -- Die Ergebenen.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Was ist der wertvollste Besitz eines jeden Grummels?"] = 3, -- Ein Glücksbringer.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welche Allianzstadt an der Dunkelküste wurde zerstört, als Todesschwinge zurückkehrte?"] = 3, -- Auberdine.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welche Goblingesellschaft ist dafür bekannt, Azeroths Naturschätze auszubeuten?"] = 2, -- Venture Company.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welche Kreaturen aus Pandaria sind die Verkörperung negativer Emotionen wie Zweifel, Verzweiflung und Zorn?"] = 4, -- Sha.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welchen Apotheker findet man während der \"Liebe liegt in der Luft\"-Feierlichkeiten in der Burg Schattenfang nicht?"] = 3, -- Copeland.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher Art von Händlerin droht Cro Dickfädel in Shattrath immer wieder?"] = 2, -- Obstverkäuferin.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher Drache nimmt die menschliche Gestalt von Lord Victor Nefarius an?"] = 3, -- Nefarian.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher Grubenlord herrschte über die Scherbenwelt, bevor er von Illidan Sturmgrimm eingesperrt wurde?"] = 4, -- Magtheridon.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher Kult, zu dem auch Nagaz und Marez Schattenkutte gehörten, wurde mit dem orcischen Schattenrat in Verbindung gebracht?"] = 3, -- Die Arguswacht.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher Orc war für die Öffnung zahlreicher Portale auf Draenor verantwortlich, wodurch die Heimatwelt der Orcs zerstört wurde?"] = 1, -- Ner'zhul.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher Paladin gehörte nicht zu den Fünf, als die Silberne Hand gegründet wurde?"] = 2, -- Alexandros.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher Sohn eines Allianzverräters sollte eines Tages zum Anführer des Syndikats werden?"] = 4, -- Aliden.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher der folgenden Effekte kann nicht durch das Trinken von Noggenfoggers Elixier erlangt werden?"] = 4, -- Feuerspucken.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welcher der folgenden ist kein Orcklan?"] = 3, -- Blutfang.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welches Auge und welchen Arm verlor Zul'jin während seiner Gefangenschaft und anschließenden Flucht?"] = 1, -- Rechtes Auge, linker Arm.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welches Gebiet wurde von den Goblins in Form des Wappens der Horde umgestaltet?"] = 1, -- Azshara.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welches Mitglied der Nachtelfen wurde mit der Bewachung Illidan Sturmgrimms beauftragt?"] = 3, -- Maiev Schattensang.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welches ist der höchste Rang, den ein Behüter der Nachtelfen erreichen kann?"] = 3, -- Wächter.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Welches musikalische Spielzeug kann andere gegen ihren Willen spontan zum Tanzen bringen?"] = 1, -- Pikkolo des Flammenfeuers.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wer war Illidans Nagaleutnant und einstige Zofe von Königin Azshara?"] = 2, -- Vashj.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wer war Jaina Prachtmeers Mentor bei den Kirin Tor?"] = 1, -- Erzmagier Antonidas.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wer war der Bruder von Varok Saurfang und der einzige Orc, der im Krieg der Ahnen kämpfte?"] = 1, -- Broxigar.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wer war der Erste, der Pandaria auf dem Rücken der Meeresschildkröte Shen-zin Su verließ?"] = 4, -- Liu Lang.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wer wurde Ragnaros' zweiter Majordomus und bewachte den Eingang der Sulfuronfestung in den Feuerlanden?"] = 1, -- Majordomus Hirschhaupt.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wer wurde nach Arthas' Niederlage zum Lichkönig?"] = 2, -- Bolvar Fordragon.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie heißt der Gefährte der Har'koa?"] = 1, -- Loque'nahak.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie heißt die Brücke, die das Arathihochland mit dem Sumpfland verbindet?"] = 4, -- Thandolübergang.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie heißt die Wüste, die die Höhlen der Zeit umgibt?"] = 2, -- Tanaris.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie hieß der Mensch, der Thrall bei der Flucht aus der Burg Durnholde geholfen hat?"] = 4, -- Taretha Foxton.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie hieß der erste Pandaren, der jemals eine Wolkenschlange zähmte?"] = 1, -- Jiang.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie lauten die letzten Worte dieses Zitats des kopflosen Reiters: \"Ihr seid am Ziel, die Suche ist vorbei. Das Schicksal soll entscheiden...\"?"] = 3, -- \"wer der Sieger sei.\"
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie lautet der Name des Menschen, der Thrall als Sklaven in der Burg Durnholde festhielt?"] = 4, -- Aedelas Schwarzmoor.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie lautet der Name des einst wohlwollenden geistlichen Führers von Sturmwind, der sich Todesschwinge anschloss?"] = 1, -- Benedictus.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wie sagt man \"Sichere Reise\" in der Sprache der Draenei?"] = 2, -- Dioniss aca.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wo in den Östlichen Königreichen befand sich Dalaran ursprünglich?"] = 3, -- Vorgebirge des Hügellands.
	["Na dann lasst uns Euer Wissen auf die Probe stellen! Wo konnte man vor dem Kataklysmus die Überreste von Mankriks Frau finden?"] = 4, -- Brachland.
}

gotAnswersFrame.Gossips = {
	-- English, 12th anniversary
	["That is correct!"] = 0,
	-- German, 12th anniversary
	["Das ist richtig!"] = 0,
	-- English, Timeless Isle
	["Without history, there would be no future."] = 0,
}

gotAnswersFrame.OnEvent = function(self, event, ...)
	-- Check if NPC is a quiz NPC
	if (gotAnswersFrame.GetTargetIsQuizNpc() ~= true) then
		return
	end

	-- Handle event
	if     event == 'GOSSIP_SHOW' then gotAnswersFrame.OnGossipShow()
	elseif event == 'QUEST_DETAIL' then gotAnswersFrame.OnQuestDetail()
	elseif event == 'QUEST_COMPLETE' then gotAnswersFrame.OnQuestComplete()
	end
end
gotAnswersFrame:SetScript('OnEvent', gotAnswersFrame.OnEvent)

gotAnswersFrame.GetTableHasValue = function(tab, val)
	for i,v in ipairs(tab) do
		if v == val then
			return true
		end
	end
	return false
end

gotAnswersFrame.GetNpcId = function(unitId)
	local guid = UnitGUID(unitId)
	if (guid == nil) then
		return 0
	end
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
	if (type == "Creature" or type == "Vehicle" or type == "GameObject" or type == "Pet") then
		return tonumber(npc_id)
	end
	return 0
end

gotAnswersFrame.GetTargetIsQuizNpc = function()
	local npcId = gotAnswersFrame.GetNpcId('target')
	-- 110034 = Historian Llore
	-- 110035 = Historian Ju'Pa
	if (npcId == 110034 or npcId == 110035 or npcId == 73570) then
		return true
	end
	return false
end

gotAnswersFrame.OnGossipShow = function(...)
	-- Accept available quest
	if GetNumGossipAvailableQuests() > 0 then
		local gossips = {GetGossipAvailableQuests()}
		local j = 0
		for i = 1,#gossips,6 do
			j = j+1
			SelectGossipAvailableQuest(j)
			return
		end
	end

	-- Turn in complete quest
	if GetNumGossipActiveQuests() > 0 then
		local gossips = {GetGossipActiveQuests()}
		local j = 0
		for i = 1,#gossips,5 do
			j = j+1
			local isComplete = gossips[i+3]
			if (isComplete == true) then
				SelectGossipActiveQuest(j)
				return
			end
		end
	end

	local text = GetGossipText()

	-- Empty gossip
	local empty = gotAnswersFrame.Gossips[text]
	if empty ~= nil then
		CloseGossip()
		return
	end

	-- Select correct answer
	local answer = gotAnswersFrame.Answers[text]
	if answer ~= nil then
		SelectGossipOption(answer)
		return
	end
	
	-- Save answers if not found
	if gotAnswersFrame.GetTableHasValue(GotAnswersConfig, text) == false then
		tinsert(GotAnswersConfig, text)
		local gossips = {GetGossipOptions()}
		for i = 1,#gossips,2 do
			local gossipText = gossips[i]
			local gossipType = gossips[i+1]
			if (gossipType == 'gossip') then
				tinsert(GotAnswersConfig, text .. '$' .. i .. '$' .. gossipText)
			end
		end
	end
end

gotAnswersFrame.OnQuestDetail = function(...)
	AcceptQuest()
end

gotAnswersFrame.OnQuestComplete = function(...)
	if GetNumQuestChoices() == 0 then
		GetQuestReward(nil)
	end
end
